import 'dart:convert';
import 'dart:io';
import 'package:flutter_test/flutter_test.dart';
import 'package:rasan_colors/controllers/data.c.dart';
import 'package:rasan_colors/models/async_form_validator.dart';

Future<Iterable<AsyncFormValidator>> getData() async {
  final file = new File('test/test_resources/data.json');
  final json = jsonDecode(await file.readAsString());
  List<Map<String, dynamic>> asyncValidationColors =
      List.of(json['groupOfColors']['asyncValidationColors'])
          .map((e) => Map<String, dynamic>.from(e))
          .toList();

  return asyncValidationColors.map((e) => AsyncFormValidator.fromJson(e));
}

void main() async {
  group("testing the dialogue generated by user's roll", () {
    test(
        'First case that the first form hides the second form if starts with letter `a` ',
        () async {
      // Arrange
      final controller = DataController();
      // Act
      controller.onChangeFirstField('Asd');
      // Assert
      expect(controller.isFirstFormStartsWithLetterA, equals(true));
    });

    test('Second case that validates async', () async {
      // Arrange
      final controller = DataController();

      // Act
      await controller.onChangeFirstField('Green', getData);

      // Assert
      expect(controller.isAsyncFormValid, equals(false));
    });
  });
}
